/****************************************************************************\
*   BINMODE - this source file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/binmode.c                                  *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of binary mode viewer.                   *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>

#include "colorset.h"
#include "bconsole.h"
#include "biewutil.h"
#include "biewhelp.h"
#include "bmfile.h"
#include "kbd_code.h"
#include "file_ini.h"
#include "reg_form.h"
#include "__os_dep.h"
#include "editor.h"

static unsigned __FASTCALL__ drawBinary( unsigned keycode,unsigned tshift )
{
 char buffer[__TVIO_MAXSCREENWIDTH];
 static unsigned long bmocpos = 0L;
 unsigned BWidth;
 int j;
 unsigned long index;
 unsigned long limit,flen,cfp;
 int len;
 cfp  = BMGetCurrFilePos();
 BWidth = Width;
 if(cfp != bmocpos || keycode == KE_SUPERKEY)
 {
   bmocpos = cfp;
   flen = BMGetFLength();
   limit = flen - BWidth;
   if(flen < (unsigned long)BWidth) BWidth = (int)(limit = flen);
   for(j = 0;j < Height;j++)
   {
     memset(buffer,TW_DEF_FILLER,BWidth);
     index = cfp + j*BWidth;
     if(index < limit) len = BWidth;
     else
       if(index < flen)  len = (int)(flen - index);
       else   len = 0;
     if(len) { lastbyte = index + len; BMReadBufferEx((void *)buffer,len,index,BM_SEEK_SET); }
     if(isHOnLine(index,BWidth)) HiLightSearch(MainWnd,index,0,BWidth,j,buffer,HLS_NORMAL);
     else                       twDirectWrite(1,j + 1,buffer,BWidth);
   }
 }
 return tshift;
}

static void __FASTCALL__ HelpBin( void )
{
   hlpDisplay(1000);
}

static unsigned long __FASTCALL__ binPrevPageSize( void ) { return Width*Height; }
static unsigned long __FASTCALL__ binCurrPageSize( void ) { return Width*Height; }
static unsigned long __FASTCALL__ binPrevLineWidth( void ) { return Width; }
static unsigned long __FASTCALL__ binCurrLineWidth( void ) { return Width; }
static const char *  __FASTCALL__ binMiscKeyName( void ) { return "Modify"; }

static tBool __FASTCALL__ binDetect( void ) { return True; }

static void __FASTCALL__ EditBin( void )
{
 TWindow *ewin;
 ewin = WindowOpen(1,2,tvioWidth,tvioHeight-1,TWS_CURSORABLE);
 twSetColorAttr(browser_cset.edit.main); twClearWin();
 drawEditPrompt();
 twUseWin(ewin);
 edit_x = edit_y = 0;
 if(editInitBuffs(tvioWidth))
 {
   FullEdit(NULL);
   editDestroyBuffs();
 }
 CloseWnd(ewin);
 PaintTitle();
}

static void __FASTCALL__ binReadIni( hIniProfile *ini )
{
}

static void __FASTCALL__ binSaveIni( hIniProfile *ini )
{
  /* Nullify LastSubMode */
  iniWriteProfileString(ini,"Biew","Browser","LastSubMode","0");
}

static unsigned __FASTCALL__ binCharSize( void ) { return 1; }

REGISTRY_MODE binMode =
{
  "~Binary mode",
  { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  binDetect,
  __MF_NONE,
  drawBinary,
  NULL,
  binCharSize,
  binMiscKeyName,
  EditBin,
  binPrevPageSize,
  binCurrPageSize,
  binPrevLineWidth,
  binCurrLineWidth,
  HelpBin,
  binReadIni,
  binSaveIni,
  NULL,
  NULL
};





